global santexToolbox_settings

rollout santexToolbox_settings "santexToolbox - Settings" width:220 height:544
(
	local maintitle="santexToolbox"
	local copyright="(c)2014 by santex"
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")+"santexToolbox.cfg")
	local devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")+"santexToolbox.log")
	
	local lbx_tools_height=64
	--label lbl0 ""
	
	group "User interface (UI):" (
	spinner spn_lbx_height "Available tools list height:" range:[1,64,lbx_tools_height] width:192 type:#integer fieldwidth:50 tooltip:"Number of tools displayed in the list" height:20 visible:false
	checkbox chk_hide_internal "Hide 'internal' tools in the list" tooltip:"Do not show 'internal' tools in the list" height:20
	checkbox chk_show_ctrl "Show UI controls (default: ON)" checked:true height:20 tooltip:"Show UI with handler controls when executing tool"
	checkbox chk_show_captions "Replace captions with IDs (Dev)" checked:true height:20 tooltip:"Replace Captions with handler IDs in the UI"
	checkbox chk_show_ctrl_captions "Show captions in UI controls (Dev)" checked:false height:20 tooltip:"Show captions in UI controls (takes two lines, more space)"
	spinner spn_ctrl_edittext_height "<Edittext> height (in pxs):" type:#integer range:[18,999,18] width:192 fieldwidth:50 tooltip:"Height of UI control <Edittext> (in pixels)"
	checkbox chk_opened "Sub-Tools rollouts should be opened" checked:false height:20 tooltip:"Sub-Tools rollouts will be opened upon Evaluation(Execution) time"
	button btn_reset_ui_settings "Reset UI settings" enabled:false tooltip:"Set UI settings to factory defaults"
	)
	group "Algorithm:" (
	spinner spn_max_recursive "Max. num. of recursive calls" range:[1,99999,1000] width:200 type:#integer fieldwidth:50 tooltip:"Maximum number of recursive calls (function / compile loops) when tools within tools are included (Not implemented)" height:20 enabled:false
	)
	group "Miscellaneous:" (
	button btn_reload_toolsets "Reload content" width:200 height:28 tooltip:"Reloads available toolsets by rescaning config folder"
	button btn_open_loc "Open configuration folder" width:200 height:28 tooltip:"Open config folder with toolsets and tools in explorer"
	button btn_export "Export toolsets / tools ..." width:200 height:28 tooltip:"Export complete toolsets or individual tools (Not implemented)" enabled:false
	button btn_import "Import toolsets / tools ..." width:200 height:28 tooltip:"Import complete toolsets or individual tools (Not implemented)" enabled:false
	button btn_reset "Reset specified settings ..." width:200 height:28 tooltip:"Choose whether to reset everything or just some specific settings to default values"
	)
	label lbl001 "" enabled:false
	group "About:" (
	--label lbl1 "---------------------------------------------------" enabled:false
	button btn_about "About ..." width:200 height:28 tooltip:"About this script"
	)
	
	
	include "santex_fnlib.ms"
	
	on btn_reload_toolsets pressed do
	(
		if (querybox "Do you really want to rescan config folder?" title:"santexToolbox") do
		(
			destroydialog santexToolbox_settings
			
			slib.workDlg.open()
			slib.workDlg.job "Loading tools ..."
			
			santexToolbox.refresh_toolset_list()
			
			slib.workDlg.close()
			
		)
	)
	
	on santexToolbox_settings open do
	(
		slib.file.init configfile "Config"
		spn_max_recursive.value=slib.setting.load "spn_max_recursive" 1000
		spn_lbx_height.value=slib.setting.load "spn_lbx_height" 8
		chk_hide_internal.checked=slib.setting.load "chk_hide_internal" false
		chk_show_ctrl.checked=slib.setting.load "chk_show_ctrl" true
		chk_show_ctrl_captions.checked=slib.setting.load "chk_show_ctrl_captions" false
		chk_show_captions.checked=slib.setting.load "santexToolbox_ui_show_captions" false
		chk_opened.checked=slib.setting.load "chk_opened" false
		spn_ctrl_edittext_height.value=slib.setting.load "spn_ctrl_edittext_height" 18
		--if (all_toolsets.count>0) then btn_export.enabled=true else btn_export.enabled=false
		
		slib.dlg.setPos santexToolbox_settings (slib.setting.load "santexToolbox_settings.pos" [0,0])
	)
	
	on btn_reset pressed do
	(
		filein "santexToolbox_reset.ms"
	)
	on btn_about pressed do
	(
		filein "santexToolbox_about.ms"
	)
	on btn_open_loc pressed do
	(
		shelllaunch cfgdir ""
	)
	on chk_hide_internal changed val do
	(
		santexToolbox_ui_hide_internal = val
		santexToolbox.refresh_tools_list()
		if val then (
			santexToolbox.btn_new_set.visible = false
			santexToolbox.btn_set_details.visible = false
			santexToolbox.btn_create.visible = false
			santexToolbox.btn_edit.visible = false
		)else (
			santexToolbox.btn_new_set.visible = true
			santexToolbox.btn_set_details.visible = true
			santexToolbox.btn_create.visible = true
			santexToolbox.btn_edit.visible = true
		)
	)
	on spn_ctrl_edittext_height changed val do
	(
		santexToolbox_ui_ctrl_edittext_height = val
		santexToolbox.refresh_tools_list()
	)
	on chk_show_ctrl changed val do
	(
		santexToolbox_ui_show_ctrl = val
		santexToolbox.refresh_tools_list()
	)
	on chk_show_ctrl_captions changed val do
	(
		santexToolbox_ui_show_ctrl_captions = val
		santexToolbox.refresh_tools_list()
	)
	on chk_show_captions changed val do
	(
		santexToolbox_ui_show_captions = val
		santexToolbox.refresh_tools_list()
	)
	on chk_opened changed val do
	(
		santexToolbox_ui_chk_opened = val
		santexToolbox.refresh_tools_list()
	)
	
	on santexToolbox_settings close do
	(
		slib.setting.save "spn_max_recursive" spn_max_recursive.value
		slib.setting.save "spn_lbx_height" spn_lbx_height.value
		slib.setting.save "chk_hide_internal" chk_hide_internal.checked
		slib.setting.save "chk_show_ctrl" chk_show_ctrl.checked
		slib.setting.save "chk_show_ctrl_captions" chk_show_ctrl_captions.checked
		slib.setting.save "santexToolbox_ui_show_captions" chk_show_captions.checked
		slib.setting.save "spn_ctrl_edittext_height" spn_ctrl_edittext_height.value
		slib.setting.save "chk_opened" chk_opened.checked
		
		try(destroydialog santexToolbox_about)catch()
		try(destroydialog santexToolbox_reset)catch()
		
		slib.setting.save "santexToolbox_settings.pos" (getDialogPos santexToolbox_settings)
	)
	
	on spn_lbx_height entered do
	(
		santexToolbox.ui_resize spn_lbx_height.value
	)
)
createdialog santexToolbox_settings modal:true